SystemOrganization addCategory: #'Comet-Core'!
SystemOrganization addCategory: #'Comet-Server'!
SystemOrganization addCategory: #'Comet-Examples'!

WARegistry subclass: #CTDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Server'!

CTDispatcher class
	instanceVariableNames: 'default'!

!CTDispatcher class methodsFor: 'accessing' stamp: 'lr 6/28/2006 15:53'!
default
	^ default ifNil: [ default := self new ]! !

!CTDispatcher methodsFor: 'handling' stamp: 'lr 6/28/2006 15:57'!
handleDefaultRequest: aRequest! !

!CTDispatcher methodsFor: 'handling' stamp: 'lr 6/28/2006 15:57'!
handleExpiredRequest: aRequest! !

!CTDispatcher methodsFor: 'configuration' stamp: 'lr 6/28/2006 15:55'!
handlerField
	^ '_c'! !

!CTDispatcher methodsFor: 'initialization' stamp: 'lr 6/28/2006 15:52'!
initialize
	super initialize.
	pusher := WeakValueDictionary new! !

!CTDispatcher methodsFor: 'public' stamp: 'lr 6/28/2006 15:52'!
register: aPusher
	pusher at: aPusher id put: aPusher! !

!CTDispatcher methodsFor: 'public' stamp: 'lr 6/28/2006 15:52'!
unregister: aPusher
	pusher removeKey: aPusher id.
	aPusher finalize! !

WAScriptLibrary subclass: #CTLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

!CTLibrary methodsFor: 'scripts' stamp: 'lr 6/26/2006 09:50'!
comet
	^ '/* Seaside Comet API
 *  (c) 2006 Lukas Renggli (renggli@iam.unibe.ch)
 */
Comet = Class.create();
Comet.prototype = {
	initialize: function(url, options) {
		this.url = url;
		this.options = Object.extend({
			reconnect: true,
			terminator: "\x00",
			interval: 100,
			onAction: eval
		}, options || {});
	}
};

Comet.HttpRequest = Class.create();
Comet.HttpRequest.prototype = {
	connect: function() {
		this.position = 0;
		this.transport = Ajax.getTransport();
		this.transport.open("get", this.url, true);
		this.transport.onreadystatechange = this.onStateChange.bind(this);
		this.transport.send(null);
		this.updater = setInterval(this.update.bind(this), this.options.interval);
	},
	disconnect: function() {
		clearInterval(this.updater); 
		this.transport.abort();
		this.transport.onreadystatechange = Prototype.emptyFunction;
	},
	isConnected: function() {
		return Ajax.Request.Events[this.transport.readyState] == "Interactive";
	},
	update: function() {
		if (this.isConnected()) {
			var response = this.transport.responseText;
			var index = response.lastIndexOf(this.options.terminator);
			if (this.position < index) {
				response
					.substring(this.position, index)
					.split(this.options.terminator)
					.each(this.options.onAction);
				this.position = index + this.options.terminator.length;
			}
		}
	},
	onStateChange: function() {
		var event = Ajax.Request.Events[this.transport.readyState];
		if (event == "Loaded") {
			this.position = this.transport.responseText ? this.transport.responseText.length : 0;
		} else if (event == "Complete") {
			this.disconnect();
			if (this.options.reconnect)
				this.connect();
		}
	}
};

Comet.Iframe = Class.create();
Comet.Iframe.prototype = {
	connect: function() {
		this.position = 0;
		this.iframe = "create iframe";
		this.iframe.onLoad = this.onLoad;
		this.iframe.location.href = this.url;
		this.updater = setInterval(this.update.bind(this), this.options.interval);
	},
	disconnect: function() {
		clearInterval(this.updater);
		this.iframe.onLoad = Prototype.emptyFunction; 
		this.iframe.location.href = '';
	},
	isConnected: function() {
		return this.iframe.location.href == this.url;
	},
	update: function() {
		if (this.isConnected()) {
			var response = this.iframe.innerHtml;
			var index = response.lastIndexOf(this.options.terminator);
			if (this.position < index) {
				response
					.substring(this.position, index)
					.split(this.options.terminator)
					.each(this.options.onAction);
				this.position = index + this.options.terminator.length;
			}
		}
	},
};'! !

!Socket methodsFor: '*comet-sending' stamp: 'lr 4/10/2006 21:56'!
pushData: aStringOrByteArray
	"Send aStringOrByteArray to the remote host trough the given socket. Push the data immediately and ignore all kinds of errors. Return true if all the data could be sent successfully, in case of problems destroy the socket and return false."

	| bytesSent bytesToSend count |
	bytesSent := 0.
	bytesToSend := aStringOrByteArray size.
	[ bytesSent < bytesToSend ] whileTrue: [
		count := self 
			primSocket: socketHandle
			sendData: aStringOrByteArray
			startIndex: bytesSent + 1
			count: (bytesToSend - bytesSent min: 5000).
		bytesSent := bytesSent + count.
		(count = 0 and: [ bytesSent ~= bytesToSend ])
			ifTrue: [ self destroy. ^ false ] ].
	^ true! !

WAExpiringHandler subclass: #CTPusher
	instanceVariableNames: 'id sockets process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Server'!

!CTPusher class methodsFor: 'instance-creation' stamp: 'lr 4/10/2006 22:56'!
new
	^ CTRegistry default register: super new! !

!CTPusher methodsFor: 'configuration' stamp: 'lr 4/12/2006 13:57'!
contentType
	^ 'text/plain'! !

!CTPusher methodsFor: 'configuration' stamp: 'lr 4/10/2006 22:46'!
delay
	^ 7500! !

!CTPusher methodsFor: 'initialization' stamp: 'lr 6/28/2006 15:15'!
finalize
	super finalize.
	process terminate.
	sockets do: [ :each | each closeAndDestroy ]! !

!CTPusher methodsFor: 'accessing' stamp: 'lr 4/9/2006 21:14'!
id
	^ id! !

!CTPusher methodsFor: 'initialization' stamp: 'lr 4/10/2006 22:41'!
initialize
	super initialize.
	id := (WAExternalID new: 24) asString.
	mutex := Semaphore forMutualExclusion.
	sockets := Array new.
	process := [ [ self process ] repeat ]
		forkAt: self priority
		named: self name! !

!CTPusher methodsFor: 'actions' stamp: 'lr 4/12/2006 12:49'!
notify: anObject
	self send: anObject asJavascript , self terminator! !

!CTPusher methodsFor: 'printing' stamp: 'lr 4/10/2006 17:15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' id: '; print: self id! !

!CTPusher methodsFor: 'configuration' stamp: 'lr 4/10/2006 22:55'!
priority
	^ 10! !

!CTPusher methodsFor: 'private' stamp: 'lr 4/12/2006 11:35'!
process
	(Delay forMilliseconds: self delay)
		wait.
	self send: self spacer! !

!CTPusher methodsFor: 'actions' stamp: 'lr 4/12/2006 11:39'!
register: aSocket
	(aSocket pushData: (String streamContents: [ :stream |
		WAResponse new
			doNotCache;
			contentType: self contentType;
			contents: (String streamContents: [ :filler |
				[ filler contents size < 1024 ]
					whileTrue: [ filler nextPutAll: self spacer ] ]);
			writeOn: stream ]))
		ifFalse: [ ^ self ].
	mutex critical: [ sockets := sockets copyWith: aSocket ]! !

!CTPusher methodsFor: 'private' stamp: 'lr 4/10/2006 22:43'!
send: aString
	mutex critical: [
		sockets := sockets select: [ :each | 
			each pushData: aString ] ]! !

!CTPusher methodsFor: 'configuration' stamp: 'lr 4/12/2006 11:35'!
spacer
	^ String with: Character space! !

!CTPusher methodsFor: 'configuration' stamp: 'lr 4/12/2006 12:49'!
terminator
	^ String with: (Character value: 0)! !

SUPrototype subclass: #CTComet
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Core'!

!CTComet methodsFor: 'private' stamp: 'lr 5/28/2006 22:00'!
defaultArguments
	^ (Array with: self url) , super defaultArguments! !

!CTComet methodsFor: 'private' stamp: 'lr 5/28/2006 22:07'!
defaultPrototype
	^ 'Comet'! !

!CTComet methodsFor: 'options' stamp: 'lr 4/12/2006 12:48'!
reconnect: aBoolean
	self optionAt: 'reconnect' put: aBoolean! !

!CTComet methodsFor: 'options' stamp: 'lr 4/12/2006 12:49'!
terminator: aString
	self optionAt: 'terminator' put: aString! !

!CTComet methodsFor: 'accessing' stamp: 'lr 5/28/2006 22:01'!
url
	^ url! !

!CTComet methodsFor: 'accessing' stamp: 'lr 5/28/2006 22:00'!
url: aString
	url := aString! !

SUFunctionalTest subclass: #SUChatTest
	instanceVariableNames: 'username message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Examples'!

SUChatTest class
	instanceVariableNames: 'pusher'!

!SUChatTest class methodsFor: 'initialization' stamp: 'lr 6/28/2006 15:18'!
initialize
	(self registerAsApplication: 'chat') libraries 
		add: SULibrary;
		add: CTLibrary.
	pusher := CTPusher new! !

!SUChatTest class methodsFor: 'accessing' stamp: 'lr 4/11/2006 20:23'!
notifier
	^ notifier! !

!SUChatTest methodsFor: 'private' stamp: 'lr 4/12/2006 12:39'!
event: aString
	self notifier notify: (SUInsertion new
		id: 'messages';
		content: '<div class="message">' , 
			'<span class="username">' , username , '</span>' ,
			'<span class="event">' , aString , '</span>' ,
			'</div>')! !

!SUChatTest methodsFor: 'initialization' stamp: 'lr 4/12/2006 15:57'!
initialize
	super initialize.
	username := ''! !

!SUChatTest methodsFor: 'accessing' stamp: 'lr 4/11/2006 07:13'!
notifier
	^ self class notifier! !

!SUChatTest methodsFor: 'rendering' stamp: 'lr 5/28/2006 22:02'!
renderContentOn: html
	html div with: (self session currentRequest
		headerAt: 'user-agent' ifAbsent: nil).
	html textInput
		id: 'username';
		value: username;
		onBlur: (html request 
			triggerFormElement: 'username');
		callback: [ :value | username := value. self event: 'Joined' ].
	html div 
		id: 'messages';
		style: 'height: 150px; overflow: auto;'.
	html script: (CTComet new url: 'http://192.168.1.100:8080/comet/' , self notifier id).
	html textInput
		id: 'message';
		style: 'width: 100%';
		callback: [ :value | self send: value ];
		onEnter: (html request 
			triggerFormElement: 'message';
			onSuccess: (SUStream on: '$("message").value = ""'))! !

!SUChatTest methodsFor: 'private' stamp: 'lr 4/12/2006 12:39'!
send: aString
	self notifier notify: (SUInsertion new
		id: 'messages';
		content: '<div class="message">' , 
			'<span class="username">' , username , '</span>' ,
			'<span class="message">' , aString , '</span>' ,
			'</div>')! !

!SUChatTest methodsFor: 'rendering' stamp: 'lr 4/11/2006 23:25'!
style
	^ 'div.message {
	margin-top: 3px;
	margin-bottom: 3px;
	background-color: #dddddd;
}
div.message span.username {
	margin-right: 1em;
	font-weight: bold;
}
div.message span.message {
}
div.message span.event {
	font-style: italic;
}
' 
! !

WAListener subclass: #CTListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comet-Server'!

!CTListener class methodsFor: 'accessing' stamp: 'lr 6/28/2006 15:22'!
cometField
	^ '_c'! !

!CTListener methodsFor: 'private' stamp: 'lr 6/28/2006 15:14'!
processComet: aRequest on: aStream
	| id pusher |
	id := aRequest fields at: self class cometField ifAbsent: [ ^ self ].
	pusher := mutex critical: [ pusher at: id ifAbsent: [ ^ self ] ].
	pusher register: aStream socket.
	thisContext swapSender: nil.
	Processor activeProcess terminate! !

!CTListener methodsFor: 'private' stamp: 'lr 6/26/2006 09:35'!
writeResponseForRequest: aRequest on: aStream
	(aRequest fields includesKey: self class cometField)
		ifTrue: [ self processComet: aRequest on: aStream ].
	super writeResponseForRequest: aRequest on: aStream! !
SUChatTest initialize!
